const isPng = require('is-png');
const isJpg = require('is-jpg');
const isGif = require('is-gif');
const isSvg = require('is-svg');

const optipng = require('./lib/optipng');
const pngquant = require('./lib/pngquant');
const pngcrush = require('./lib/pngcrush');
const zopflipng = require('./lib/zopflipng');
const jpegRecompress = require('./lib/jpeg-recompress');
const jpegoptim = require('./lib/jpegoptim');
const mozjpeg = require('./lib/mozjpeg');
const gifsicle = require('./lib/gifsicle');
const svgo = require('./lib/svgo');

module.exports = function(buffer, options) {
  if (isJpg(buffer)) {
    return Promise.resolve(buffer)
      .then(buffer => options.jpegRecompress ? jpegRecompress(buffer) : buffer)
      .then(buffer => options.jpegoptim ? jpegoptim(buffer) : buffer)
      .then(buffer => options.mozjpeg ? mozjpeg(buffer) : buffer);
  } else if (isPng(buffer)) {
    return Promise.resolve(buffer)
      .then(buffer => options.pngquant ? pngquant(buffer) : buffer)
      .then(buffer => options.optipng ? optipng(buffer) : buffer)
      .then(buffer => options.zopflipng ? zopflipng(buffer) : buffer)
      .then(buffer => options.pngcrush ? pngcrush(buffer) : buffer);
  } else if (isGif(buffer)) {
    return Promise.resolve(buffer)
      .then(buffer => options.gifsicle ? gifsicle(buffer) : buffer);
  } else if (isSvg(buffer)) {
    return Promise.resolve(buffer)
      .then(buffer => options.svgo ? svgo(buffer) : buffer);
  }

  return Promise.resolve(buffer);
};
