# imgo

Optimize buffer of PNG, JPEG, GIF, SVG images.

## Install

```bash
$ npm install imgo
```

## Usage

### JavaScript

```javascript
const fs = require('fs');
const imgo = require('imgo');

fs.readFile('image.png', (error, data) => {
  imgo(data, {
    pngquant  : true,
    optipng   : true,
    zopflipng : true,
    pngcrush  : true
  }).then(optimized => {
    console.log('optimized image buffer', optimized);
  });
});

fs.readFile('image.jpg', (error, data) => {
  imgo(data, {
    jpegRecompress : true,
    jpegoptim      : true,
    mozjpeg        : true
  }).then(optimized => {
    console.log('optimized image buffer', optimized);
  });
});

fs.readFile('image.gif', (error, data) => {
  imgo(data, {
    gifsicle : true
  }).then(optimized => {
    console.log('optimized image buffer', optimized);
  });
});

fs.readFile('image.svg', (error, data) => {
  imgo(data, {
    svgo : true
  }).then(optimized => {
    console.log('optimized image buffer', optimized);
  });
});
```

### CLI

```bash
# imgo help
$ imgo --help

# apply optipng and pngquant
$ cat image.png | imgo --optipng --pngquant > optimized.png

# apply all jpeg optimizers and out diff
$ cat image.jpg | imgo --jpg --info > optimized.jpg
```

## License

MIT: http://1000ch.mit-license.org
